#include <stdio.h>
#include <stdlib.h>
#include <stdbool.h>
#include <time.h>

#include "bst.h"

#define MAX_NUMS 20

void print_val(void * data)
   {
   printf("%d", *((int *) data));
   }

bool le(void *a, void * b)
   {
   return *((int *) a) <= *((int *) b);
   }

bool eq(void *a, void * b)
   {
   return *((int *) a) == *((int *) b);
   }

void print(void * d)
   {
   printf("%d\n", *((int *) d) );
   }

void free_data(void * d)
   {
   free(d);
   }

int main(int argc, char ** argv)
   {
   int sorted[100] = {
   35005211, 42999170, 84353895, 135497281, 137806862, 149798315, 184803526, 233665123, 278722862, 294702567,
   304089172, 336465782, 356426808, 412776091, 424238335, 468703135, 491705403, 511702305, 521595368, 572660336,
   596516649, 608413784, 610515434, 628175011, 635723058, 709393584, 719885386, 749241873, 752392754, 756898537,
   760313750, 783368690, 805750846, 846930886, 855636226, 859484421, 861021530, 939819582, 943947739, 945117276,
   982906996, 1025202362, 1059961393, 1100661313, 1101513929, 1102520059, 1125898167, 1129566413, 1131176229, 1141616124,
   1159126505, 1189641421, 1264095060, 1303455736, 1315634022, 1350490027, 1365180540, 1369133069, 1374344043, 1411549676,
   1424268980, 1433925857, 1469348094, 1474612399, 1477171087, 1540383426, 1548233367, 1585990364, 1632621729, 1649760492,
   1653377373, 1656478042, 1681692777, 1714636915, 1726956429, 1734575198, 1749698586, 1780695788, 1801979802, 1804289383,
   1827336327, 1843993368, 1889947178, 1911759956, 1914544919, 1918502651, 1937477084, 1956297539, 1957747793, 1967513926,
   1973594324, 1984210012, 1998898814, 2001100545, 2038664370, 2044897763, 2053999932, 2084420925, 2089018456, 2145174067,
   };

   struct bst * bst = bst_new(le, eq);
   if (NULL == bst)
      {
      perror("bst_new");
      exit(EXIT_FAILURE);
      }

   ////////////////////////////////////////
   printf ("======================\nGenerating\n");
   //srand(time());
   int * ip;
   for (int i = 0 ; i < MAX_NUMS ; ++i)
      {
      ip = malloc(sizeof(int));
      if (NULL == ip)
	 {
	 perror("malloc");
	 exit(EXIT_FAILURE);
	 }

      *ip = rand();
      //      *ip = sorted[i];
      printf("%d\n", *ip);
      if (NULL == bst_insert(bst, ip))
	 {
	 perror("bst_insert");
	 exit(EXIT_FAILURE);
	 }
      }
   printf ("======================\n");


   bst_dump(bst, print_val);

   ////////////////////////////////////////
   bst_walk_inorder(bst, print);

   ////////////////////////////////////////
   int i = 1;
   int * p = (int *) bst_search(bst, &i);
   if (NULL == p)
      printf("%d NOT FOUND\n", i);
   else
      printf("%d FOUND\n", i);

   i = *ip;
   p = (int *) bst_search(bst, &i);
   if (NULL == p)
      printf("%d NOT FOUND\n", i);
   else
      printf("%d FOUND\n", i);

   i = *ip;
   p = (int *) bst_search_iterative(bst, &i);
   if (NULL == p)
      printf("%d NOT FOUND\n", i);
   else
      printf("%d FOUND\n", i);


   int * min = bst_minimum(bst);
   if (NULL == min)
      printf("tree has no minimum.  empty?\n");
   else
      printf("%d MINIMUM\n", *min);

   int * max = bst_maximum(bst);
   if (NULL == max)
      printf("tree has no maximum.  empty?\n");
   else
      printf("%d MAXIMUM\n", *max);

   ////////////////////////////////////////
   printf("\n\nWalking inorder with iterators\n");
   struct bst_iterator * it = bst_begin(bst);
   if (NULL == it)
      {
      perror("bst_begin");
      exit(EXIT_FAILURE);
      }
   do
      printf("%d\n", *((int *) bst_value(it)));
   while (bst_next(it));
   free(it);


   ////////////////////////////////////////
   printf("\n\nWalking reverse inorder with iterators\n");
   it = bst_end(bst);
   if (NULL == it)
      {
      perror("bst_end");
      exit(EXIT_FAILURE);
      }
   do
      printf("%d\n", *((int *) bst_value(it)));
   while (bst_prev(it));
   free(it);


   ////////////////////////////////////////
   printf("========================================\nRemoving third element\n");
   it = bst_begin(bst);
   if (NULL == it)
      {
      perror("bst_begin");
      exit(EXIT_FAILURE);
      }
   bst_next(it);
   bst_next(it);
   void * d = bst_remove(it);
   if (NULL == d)
      printf("Unable to remove element!\n");
   else
      free(d);
   free(it);
   it = bst_begin(bst);
   do
      printf("%d\n", *((int *) bst_value(it)));
   while (bst_next(it));
   free(it);



   ////////////////////////////////////////
   bst_walk_inorder(bst, free_data);
   bst_delete(bst);

   exit(EXIT_SUCCESS);
   }
